 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

 public class DetourLib extends NslClass/*()*/
{				
	static  void gauss1D(NslDouble1 kernel, NslDouble0 sigma)
	{
  		//int xn = kernel.get_imax();
  		 int xn = kernel.getSize1();
  		 double sig = sigma.get();
  		 int k = xn/2;  		
  		//nslConst Double PI = 3.14159; 
  		/* verbatim NSLJ */
  		final double PI = 3.14159; 
  		 /* verbatim off */
  		// Es con minuscula, pero truena
  		// Truena con acentos en los comentarios
  		 double f= sig*NslOperator.sqrt.eval(2.0*PI);
  		//Double f = sig*NslSqrt.value(2.0*3.14159);
  		// NslSqrt no esta declarada como estatic
  		// por eso truena la linea de arriba

		for ( int i=-k; i <= k - (1 - xn%2); i++)
	    	(kernel).set((i)+(k),(NslOperator.exp.eval((-((i)*(i)))/(((2)*(sig))*(sig))))/(f));
	}

	static  void gauss2D(NslDouble2 kernel, NslDouble0 sigma)	
	{
  		//int xn = kernel.get_imax(); // getSize1 (getRows)
  		//int yn = kernel.get_jmax(); // getSize2 (getCols)
  		 int xn = kernel.getSize1();
  		 int yn = kernel.getSize2();

  		 double sig = sigma.get();
                 
                 if( sig != 0) {
                    int k1 = xn/2;
                    int k2 = yn/2;
                    //Double PI = 3.14159;
                    //Double f= sig*NslSqrt.value(2.0*PI);
                    double f= sig*NslOperator.sqrt.eval(2.0*3.14159);

                    for ( int i=-k1; i<=k1 - (1 - xn%2); i++)
                    for ( int j=-k2; j<=k2 - (1 - yn%2); j++)
                    	(kernel).set((i)+(k1),(j)+(k2),(NslOperator.exp.eval((-(((i)*(i))+((j)*(j))))/(((2)*(sig))*(sig))))/(f));
                 }
                 else
                     System.out.println("Error: Sig  = 0");
	}

	static  NslDouble1 maxim(NslDouble1 u)
	// returns the vector normalized (substraction) by its maximum.
	// only the maximum is above threshold (by 0.01).
	{
		//int imax = u.get_imax(); 
		 int size = u.getSize1(); //evitar problemas de bordes se usa (imin=1, imax=size-1)
                 int imax = size;// - 1;
                 int imin = 0; //1;
		NslDouble1 c = new NslDouble1(size);

		 double max = 0.0;			// Maximum value
		 int max_i=0;			// Coordinates of max value
                
 /*              u.set(0,(0.0));
               u.set(imax, (0.0));
               u.set(1,(0.0));
               u.set(imax-1, (0.0));
               c.set(0,-(0.01));
               c.set(imax, -(0.01));
*/	
		max=NslMaxValue.eval(u)/* rule 102*/;
                
		if (max == 0)
	 		for ( int i=imin; i < imax; i++)
				(c).set(i,-(0.01));
		else
			for ( int i=imin; i < imax; i++)
				(c).set(i,(((u).get(i))-(max))+(0.01));

		c.set(NslStep.eval(c)) /* rule 108 */;
		 return c;
	}

	static  NslDouble2 filter(NslDouble2 view, int f)
	// filters out all the elements in the matrix that do not have a 
	// value of "f". Simplified feature detector where "f" is the feature.
	{
		 int i,j;
		//int imax = view.get_imax();
		 int imax = view.getSize1();
		NslDouble2 c = new NslDouble2(imax, imax);

		for (i=0; i<imax; i++)
	  		for (j=0; j<imax; j++)
				if (((view).get(i,j))==(f))
					(c).set(i,j,1);
				else 
					(c).set(i,j,0);	

		 return c;
	}
	/* nslInitTempClass inserted by NPP */
public void nslInitTempClass() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	/* constructor and related methods */
	/* nsl declarations */

	 /*GENERIC CONSTRUCTOR:   */
	 public DetourLib(String nslName, NslModule nslParent) {
		super(nslName, nslParent);
		makeInst(nslName, nslParent);
	}

	 public DetourLib(String nslName, NslClass nslParent) {
		super(nslName, nslParent);
		makeInst(nslName, nslParent);
	}
	public void makeInst(String nslName, NslModule nslParent){ 
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic instantiation statements */
	}
	public void makeInst(String nslName, NslClass nslParent){ 
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic instantiation statements */
	}
	/* end of automatic declaration statements */
}
