%{
package patch.src;
import java.util.*;
import java.io.*;
import java.lang.System;
import patch.src.util.*;
import pp.src.jbf.*;

// import patch.src.jbf.*;

class Utility {
  public static void assert
    (
     boolean expr
     )
      {
        if (false == expr) {
          throw (new Error("Error: Assertion failed."));
        }
      }
 
  private static final String errorMsg[] = {
    "Error: Unmatched end-of-comment punctuation.",
    "Error: Unmatched start-of-comment punctuation.",
    "Error: Unclosed string.",
    "Error: Illegal character."
    };

  public static final int E_ENDCOMMENT = 0;
  public static final int E_STARTCOMMENT = 1;
  public static final int E_UNCLOSEDSTR = 2;
  public static final int E_UNMATCHED = 3;

  public static void error
    (
     int code
     )
      {
        System.out.println(errorMsg[code]);
      }
}


%}
%s COMMENT

IDENTIFIER              [A-Za-z_$][A-Za-z_$0-9]*
IDENT_ARR       {IDENTIFIER}{WHITESPACE}*"["[^=,;]*"]"
WHITESPACE              [ \n\r\t]+
ONELINECOMMENT          "//".*
OLD_CCOMMENT            "/*"([^("/*")]|\n)*"*/"
CCOMMENT                "/""*"+(("/"+[^*])?("*"[^/]|[^*/])*)*"*"+"/"
HARD_COMMENT            {WHITESPACE}|{ONELINECOMMENT}|{CCOMMENT}
CHAR_OP         [,;()[\].&|!~=+*/%<>^?:@]


%%

<INITIAL>"/*" { yybegin(COMMENT); comment_count = comment_count + 1; }

<COMMENT>"/*" { comment_count = comment_count + 1; }
<COMMENT>"*/" {
        comment_count = comment_count - 1;
        Utility.assert(comment_count >= 0);
        if (comment_count == 0) {
                yybegin(INITIAL);
        }
}
<COMMENT>. { }
<INITIAL>"//".* { }

<INITIAL>"abstract" { yyreturn(new YYtoken(YYtokentypes.ABSTRACT,yytext));}
<INITIAL>"boolean" { yyreturn(new YYtoken(YYtokentypes.BOOLEAN,yytext));}
<INITIAL>"byte" { yyreturn(new YYtoken(YYtokentypes.BYTE,yytext));}
<INITIAL>"char" { yyreturn(new YYtoken(YYtokentypes.CHAR, yytext));}
<INITIAL>"class" { yyreturn(new YYtoken(YYtokentypes.CLASS,yytext));}
<INITIAL>"double" { yyreturn(new YYtoken(YYtokentypes.DOUBLE,yytext));}
<INITIAL>"float" { yyreturn(new YYtoken(YYtokentypes.FLOAT,yytext));}
<INITIAL>"extends" { yyreturn(new YYtoken(YYtokentypes.EXTENDS, yytext));}
<INITIAL>"final" { yyreturn(new YYtoken(YYtokentypes.FINAL, yytext));}
<INITIAL>"implements" { yyreturn(new YYtoken(YYtokentypes.IMPLEMENTS, yytext));}
<INITIAL>"int" { yyreturn(new YYtoken(YYtokentypes.INT     ,yytext));}
<INITIAL>"interface" { yyreturn(new YYtoken(YYtokentypes.INTERFACE, yytext));}
<INITIAL>"long" { yyreturn(new YYtoken(YYtokentypes.LONG    ,yytext));}
<INITIAL>"private" { yyreturn(new YYtoken(YYtokentypes.PRIVATE , yytext));}
<INITIAL>"protected" { yyreturn(new YYtoken(YYtokentypes.PROTECTED, yytext));}
<INITIAL>"public" { yyreturn(new YYtoken(YYtokentypes.PUBLIC, yytext));}
<INITIAL>"short" { yyreturn(new YYtoken(YYtokentypes.SHORT, yytext));}
<INITIAL>"static" { yyreturn(new YYtoken(YYtokentypes.STATIC, yytext));}
<INITIAL>"transient" { yyreturn(new YYtoken(YYtokentypes.TRANSIENT, yytext));}
<INITIAL>"volatile" { yyreturn(new YYtoken(YYtokentypes.VOLATILE , yytext));}
<INITIAL>"void" { yyreturn(new YYtoken(YYtokentypes.VOID , yytext));}
<INITIAL>"{" { yyreturn(new YYtoken((yytext.lexeme()).charAt(0), yytext));}
<INITIAL>"}" { yyreturn(new YYtoken((yytext.lexeme()).charAt( 0), yytext));}
<INITIAL>{CHAR_OP} { yyreturn(new YYtoken((yytext.lexeme()).charAt(0), yytext));}
<INITIAL>"-" { yyreturn(new YYtoken((yytext.lexeme()).charAt(0), yytext));}


<INITIAL>{IDENTIFIER} {
YYtoken t =new YYtoken(YYtokentypes.SYMBOL, yytext); 
yyreturn(t);
}


%%
private int comment_count = 0;

npp.src.util.NslPreProcessor p;

public void init(npp.src.util.NslPreProcessor pat) {
// pat.setWholeBuffer(yytext.wholebuffer);
}

/*
public void init(npp.src.NPP pat) {
// pat.setWholeBuffer(yytext.wholebuffer);
}
*/

