// Funciona

nslImport nslAllImports;

nslModule MHM (int tectsize) 
{
	public NslDinFloat1 baf(tectsize);			
	public NslFloat1 in(tectsize);
	public NslDinFloat1 gapsf(tectsize);
	public NslDinFloat1 preyHorF(tectsize);			
	public NslDoutFloat1 mhm(tectsize);
	//public NslDoutFloat0 ps();
	public NslDouble0 ps();
	public NslFloat0 d_norm();
	public NslFloat0 d_mhm();
	public NslDinFloat0 pspa();
	public NslDinFloat0 psoa();
	private NslFloat1 mhm_hat(tectsize);		// Predictive MHM.
	private NslFloat0 field_A();
	private NslFloat0 field_center();
	private NslFloat0 rspa();
	private NslFloat0 rsoa();

	public void initSys()
	{
		rspa = 1.0;	
		rsoa = 1.0;	
		ps = 0;
	}

	public void simRun()
	{
		// Dynamics of Motor Heading Map (MHM): integrating several fields.
		// New fields can also be added while learning.

		if (d_mhm > d_norm)
		{			 
			baf[field_center.getint()] = field_A;
			in = baf; // New Field "inserted"
		}
		else
			in = 0; // reset input (cf. antidromic
		
		mhm_hat = mhm;					// Predictive MHM.
		mhm = gapsf + preyHorF + baf + in;		// Fields over MHM.		

		ps = ps + rspa*pspa + rsoa*psoa;   		
   		ps = NslSigmoid.eval(ps,-1.0,1.0,-1.0,1.0);	
	}
}
