/*
 * RobotControllerComm.java
 *
 * Created on November 7, 2002, 1:51 PM
 */

package cannes.DetourServletComm;


import java.net.*;
import java.io.*;
/**
 *
 * @author  rodolfo
 */
public class RobotControllerComm {
    
    /** Creates a new instance of RobotControllerComm */
    public RobotControllerComm() {
    }
    
    public String sendRequest(String host, String portString, String uri,
                              String data) {
            try {
      String protocol = "http";

      int port;
      try {
        port = Integer.parseInt(portString);
      } catch(NumberFormatException nfe) {
        port = -1; // I.e., default port of 80
      }
      
      URL dataURL = new URL(protocol, host, port, uri);
      
      System.out.println( dataURL );
      
      URLConnection connection = dataURL.openConnection();
      
      // Make sure browser doesn't cache this URL.
      connection.setUseCaches(false);
      
      // Tell browser to allow me to send data to server.
      connection.setDoOutput(true);
      
      ByteArrayOutputStream byteStream =
        new ByteArrayOutputStream(512); // Grows if necessary
      // Stream that writes into buffer
      PrintWriter out = new PrintWriter(byteStream, true);
      String postData = data;
      
      // Write POST data into local buffer
      out.print(postData);
      out.flush(); // Flush since above used print, not println

      // POST requests are required to have Content-Length
      String lengthString =
        String.valueOf(byteStream.size());
      connection.setRequestProperty
        ("Content-Length", lengthString);
      
      // Netscape sets the Content-Type to multipart/form-data
      // by default. So, if you want to send regular form data,
      // you need to set it to
      // application/x-www-form-urlencoded, which is the
      // default for Internet Explorer. If you send
      // serialized POST data with an ObjectOutputStream,
      // the Content-Type is irrelevant, so you could
      // omit this step.
      connection.setRequestProperty
        ("Content-Type", "application/x-www-form-urlencoded");
      
      // Write POST data to real output stream
      byteStream.writeTo(connection.getOutputStream());

      BufferedReader in =
        new BufferedReader(new InputStreamReader
                             (connection.getInputStream()));
      String line;
      String end = "";
      
      
      while((line = in.readLine()) != null) {
        end = end + line + "\n";
      }
      
      return end;
      
    } catch(IOException ioe) {
      // Print debug info in Java Console
      System.out.println( ioe );
      return "ERROR";
    }
    }
           
    /*public static void main(String[] args) {
        RobotControllerComm com = new RobotControllerComm();
        
        System.out.println(
        com.sendRequest("arkin.cannes.itam.mx", "8080", "/Detour/RobotControl", "derecha", "10") 
        );
    }*/
}
    
