// Funciona

nslImport nslAllImports;

// Frog

nslModule Frog (int wx,int wz,int recsize,int tectsize,int tx,int ty,int rrf) 
{
	public NslDinFloat2 worldXZ(wx,wz);  
	public NslDoutDouble0 xf();
	public NslDoutDouble0 yf();
	public NslDoutDouble0 zf();	
	public NslDinDouble0 xw();
	public NslDinDouble0 yw();
	public NslDinDouble0 zw();	
	public NslDinDouble0 xb_init();
	public NslDinDouble0 xb_end();
	public NslDinDouble0 yb();
	public NslDinDouble0 zb();
	
	public NslDoutFloat0 forward_step();
	public NslDoutFloat0 backward_step();
	public NslDoutFloat0 wangle();
	public NslDoutFloat0 angle();

	private VisualField visual(wx,wz,recsize);
	private Depth depth();
	private Tactile tactile();
	private PreyRec preyRec(recsize,tx,ty);
	private SorRec sorRec(recsize,tx,ty);
	private PreyApproach preyApproach(tx,ty);
	private SorAvoid sorAvoid(tectsize,tx,ty,rrf);
	private BumpAvoid bumpAvoid(tectsize);
	private MHM mhm(tectsize);
	private WTA wta(tectsize);
	private Xform xform(tectsize);
	private Forward forward();
	private Sidestep sidestep();
	private Backward backward();
			
	private NslFloat0 safeDistance();

	public void makeConn()
	{
		nslRelabel (worldXZ,visual.worldXZ);
		nslRelabel (xb_init,depth.xb_init);
		nslRelabel (xb_end,depth.xb_end);
		nslRelabel (yb,depth.yb);
		nslRelabel (sidestep.out,angle);
		nslRelabel (forward.out,forward_step);
		nslRelabel (backward.out,backward_step);
		nslRelabel (xw,depth.xw);	
		nslRelabel (yw,depth.yw);

		nslConnect (xf,visual.xf);
		nslConnect (zf,visual.zf);
		nslConnect (xf,depth.xf);	
		nslConnect (yf,depth.yf);
	
		nslConnect (visual.visualField,preyRec.visualField);
		nslConnect (visual.visualField,sorRec.visualField);
		nslConnect (depth.ps,forward.psdp);	
		nslConnect (depth.depthY,tactile.depthY);
		nslConnect (depth.depthX,tactile.depthX);
		nslConnect (depth.depthY,sorRec.depthY);
		nslConnect (depth.depthX,sorRec.depthX);
		nslConnect (depth.depthY,bumpAvoid.depthY);
		nslConnect (depth.depthX,bumpAvoid.depthX);
		nslConnect (depth.depthY,forward.depthY);
		nslConnect (tactile.ps,bumpAvoid.psta);	
		nslConnect (tactile.ps,forward.psta);	
		nslConnect (tactile.ps,sidestep.psta);	
		nslConnect (tactile.ps,backward.psta);	
		nslConnect (preyRec.t5_2f,preyApproach.t5_2f);
		nslConnect (preyRec.ps,preyApproach.psfo);		
		nslConnect (preyRec.ps,forward.psfo);	
		nslConnect (sorRec.th10f,sorAvoid.th10f);
		nslConnect (sorRec.ps,sorAvoid.psso);	
		nslConnect (sorRec.ps,sidestep.psso);
		nslConnect (preyApproach.preyHor_f,mhm.preyHorF);		
		nslConnect (preyApproach.ps,mhm.pspa);	
		nslConnect (preyApproach.ps,xform.pspa);	
		nslConnect (sorAvoid.gapsf,bumpAvoid.gaps);		
		nslConnect (sorAvoid.ps,mhm.psoa);	
		nslConnect (sorAvoid.ps,xform.psoa);	
		nslConnect (bumpAvoid.baf,mhm.baf);		
		nslConnect (bumpAvoid.ps,sidestep.psba);	
		nslConnect (bumpAvoid.ps,backward.psba);	
		nslConnect (bumpAvoid.gapsf,mhm.gapsf);		
		nslConnect (mhm.ps,forward.psmhm);	
		nslConnect (mhm.ps,sidestep.psmhm);	
		nslConnect (mhm.mhm,wta.mhm);	
		nslConnect (wta.wta_mhm,xform.wta_mhm);	
		nslConnect (xform.angle,sidestep.angle);	
		nslConnect (xform.ps,sidestep.psx);	
		nslConnect (forward.ps,backward.psfw);	
		nslConnect (backward.ps,forward.psbk);	
	}

	public void endRun()
	{
		double pi = 3.1415926535;
		double iangle = 0;

		double x0 = xf.getdouble() - xb_init.getdouble();
		double x2 = xb_end.getdouble() - xf.getdouble();
		double yd = yf.getdouble() - yb.getdouble();

		double x1 = xf.getdouble() - xw.getdouble();
		double y1 = yf.getdouble() - yw.getdouble();

		double xd = angle.getdouble() - yd*x1/y1; 
		
		verbatim_NSLJ;
  		double t = NslOperator.atan.eval(xd/yd);
  		verbatim_off;
		double disp = forward_step.getdouble() - backward_step.getdouble(); // overall displacement		
		verbatim_NSLJ;
  		double dispx = NslOperator.abs.eval(disp)*NslOperator.sin.eval(t);
  		verbatim_off;		
		
		verbatim_NSLJ;
  		double dispy = disp*NslOperator.cos.eval(t);
  		verbatim_off;		
		double dispx0 = dispx;
		double dispy0 = dispy;

		if (yf > yb && (yf.getdouble() - dispy < yb + safeDistance) && 
			(xf.getdouble() + dispx > xb_init - safeDistance) && 
			(xf.getdouble() + dispx < xb_end + safeDistance)) 
		{
			dispy = yf.getdouble() - yb.getdouble() - (double)safeDistance; // maximum movement
			dispx = dispx0*dispy/dispy0;
		}

		yf = yf.getdouble() - dispy;

		if ((yf >= yb - safeDistance) && (yf <= yb + safeDistance))
		{
			if ((xf.getdouble() + dispx < xb_init.getdouble()) && (xf.getdouble() + dispx > xb_init - safeDistance))
				dispx = xb_init.getdouble() - xf.getdouble() - safeDistance.getdouble(); // maximum movement
			else if ((xf.getdouble() + dispx > xb_end.getdouble()) && (xf.getdouble() + dispx < xb_end + safeDistance))
				dispx = xf.getdouble() - xb_end.getdouble() + (double)safeDistance; // maximum movement
		}

		xf = xf.getdouble() + dispx; 

		if (yf <= yw)
		{
			nslPrintln("Ate Worm");
			yf = yw;
			xf = xw; 

			//system.breakEpoch();
			return;
		}

		double x = 0, y = 0;

		x = xf.getdouble() - xw.getdouble();
		y = yf.getdouble() - yw.getdouble();

		if (y != 0) 
		{
			verbatim_NSLJ;
  			iangle = NslOperator.atan.eval(x/y);
  			verbatim_off;		
			wangle = iangle*180/pi;
		}
		else 
		{
			iangle = pi/2;
			wangle = 90;
		}
	}
}
