// Funciona

 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

 public class BumpAvoid extends NslModule /*(int tectsize)*/ 
{
	public NslDinFloat0 depthY ; /*()*/
	public NslDinFloat0 depthX ; /*()*/
	public NslDoutFloat1 baf ; /*(tectsize)*/			
	public NslDinFloat1 gaps ; /*(tectsize)*/
	public NslDoutFloat1 gapsf ; /*(tectsize)*/
	//public NslDoutFloat0 ps();
	public NslDouble0 ps ; /*()*/
	public NslDinFloat0 psta ; /*()*/
	private NslFloat0 field_A ; /*()*/
	private NslFloat0 field_center ; /*()*/
	private NslFloat0 tune_tm ; /*()*/	// TUNE GAPS field (avoid bumping).
	private NslFloat0 tune_tm_base ; /*()*/
	private NslFloat1 tune_tm_layer ; /*(tectsize)*/
	private NslFloat0 safeDistance ; /*()*/
	private NslFloat0 rsta ; /*()*/
	private NslFloat0 th ; /*()*/

	public  void initSys()
	{
		rsta.set(1.0);	// Tactile & Bumping Avoid
		ps.set(0);
	}

	public  void simRun()
	{
		// both should be larger than zero for no bump
		if ((
 nslj.src.math.NslLeq.eval(depthY.get(),safeDistance.get()))&&(
 nslj.src.math.NslLeq.eval(depthX.get(),safeDistance.get()))) 	//Bumping.   
			ps.set(0);
		else
			ps.set(-(1.0));		// Go down fast: -2.0

		if (
 nslj.src.math.NslLes.eval(tune_tm.get(),1.5))		// saturate tune_tm.
			tune_tm.set(
 nslj.src.math.NslAdd.eval(tune_tm.get(),tune_tm_base.get()));

		tune_tm_layer.set(tune_tm);
		tune_tm_layer.set(
 __nsltmp102=nslj.src.math.NslElemMult.eval(__nsltmp102,tune_tm_layer.get(),NslStep.eval(
 __nsltmp101=nslj.src.math.NslSub.eval(__nsltmp101,0,gaps.get()))));	// Modulate only already active neurons.

		gaps.set(
 __nsltmp103=nslj.src.math.NslSub.eval(__nsltmp103,gaps.get(),tune_tm_layer.get())); // gaps fields gets tuned.
		gapsf.set(gaps);

		ps.set(
 nslj.src.math.NslAdd.eval(ps.get(),
 nslj.src.math.NslElemMult.eval(rsta.get(),psta.get())));
   		//ps = nslSigma(ps,-1.0,1.0,-1.0,1.0);	
   		ps.set(NslSigmoid.eval(ps,-(1.0),1.0,-(1.0),1.0)) /* rule 108 */;

		// every bump it increases tune_tm until it reaches a saturation point.
		if (
 nslj.src.math.NslGtr.eval(ps.get(),th.get()))
		{
			field_center.set(
 nslj.src.math.NslAdd.eval(field_center.get(),.3));	// Tunes baf by increasing eccentricity.
			(baf).set(field_center.getint(),field_A); // Generate Bumping Avoidance FIELD.
		}
		else
			baf.set(0);
	}
	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	__nsltmp101 = new float[1];
	__nsltmp102 = new float[1];
	__nsltmp103 = new float[1];
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	for (int i = 0; i < __nsltmp101.length; i++) {
		__nsltmp101[i] = 0;
}
	for (int i = 0; i < __nsltmp102.length; i++) {
		__nsltmp102[i] = 0;
}
	for (int i = 0; i < __nsltmp103.length; i++) {
		__nsltmp103[i] = 0;
}
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	private  float[] __nsltmp101;
	private  float[] __nsltmp102;
	private  float[] __nsltmp103;
	/* constructor and related methods */
	/* nsl declarations */
	int tectsize;

	 /*GENERIC CONSTRUCTOR:   */
	 public BumpAvoid(String nslName, NslModule nslParent,int tectsize) {
		super(nslName, nslParent);
		this.tectsize = tectsize;
		initSys();
		makeInst(nslName, nslParent,tectsize);
	}
	public void makeInst(String nslName, NslModule nslParent,int tectsize){ 
	 depthY=new NslDinFloat0 ("depthY",this); //NSLDECLS 
	 depthX=new NslDinFloat0 ("depthX",this); //NSLDECLS 
	 baf=new NslDoutFloat1 ("baf",this,tectsize); //NSLDECLS 
	 gaps=new NslDinFloat1 ("gaps",this,tectsize); //NSLDECLS 
	 gapsf=new NslDoutFloat1 ("gapsf",this,tectsize); //NSLDECLS 
	 ps=new NslDouble0 ("ps",this); //NSLDECLS 
	 psta=new NslDinFloat0 ("psta",this); //NSLDECLS 
	 field_A=new NslFloat0 ("field_A",this); //NSLDECLS 
	 field_center=new NslFloat0 ("field_center",this); //NSLDECLS 
	 tune_tm=new NslFloat0 ("tune_tm",this); //NSLDECLS 
	 tune_tm_base=new NslFloat0 ("tune_tm_base",this); //NSLDECLS 
	 tune_tm_layer=new NslFloat1 ("tune_tm_layer",this,tectsize); //NSLDECLS 
	 safeDistance=new NslFloat0 ("safeDistance",this); //NSLDECLS 
	 rsta=new NslFloat0 ("rsta",this); //NSLDECLS 
	 th=new NslFloat0 ("th",this); //NSLDECLS 
	}
	/* end of automatic declaration statements */
}
