nslImport nslAllImports;

nslClass DetourLib()
{				
	static void gauss1D(NslFloat1 kernel, NslFloat0 sigma)
	{
  		//int xn = kernel.get_imax();
  		int xn = kernel.getSize1();
  		double sig = sigma.getfloat();
  		double k = xn/2;  		
  		//nslConst float PI = 3.14159; 
  		verbatim_NSLJ;
  		final double PI = 3.14159; 
  		verbatim_off;
  		// Es con minuscula, pero truena
  		// Truena con acentos en los comentarios
  		double f= sig*NslSqrt.value(2.0*PI);
  		//float f = sig*NslSqrt.value(2.0*3.14159);
  		// NslSqrt no esta declarada como estatic
  		// por eso truena la linea de arriba

		for (int i=-k; i <= k - (1 - xn%2); i++)
	    	kernel[i+k] = nslExp(-(i*i)/(2*sig*sig))/f;
	}

	static void gauss2D(NslFloat2 kernel, NslFloat0 sigma)	
	{
  		//int xn = kernel.get_imax(); // getSize1 (getRows)
  		//int yn = kernel.get_jmax(); // getSize2 (getCols)
  		int xn = kernel.getSize1();
  		int yn = kernel.getSize2();

  		double sig = sigma.getfloat();
  		int k1 = xn/2;
  		int k2 = yn/2;
  		//float PI = 3.14159;
  		//float f= sig*NslSqrt.value(2.0*PI);
  		double f= sig*NslSqrt.eval(2.0*3.14159);

  		for (int i=-k1; i<=k1 - (1 - xn%2); i++)
    		for (int j=-k2; j<=k2 - (1 - yn%2); j++)
      			kernel[i+k1][j+k2] = nslExp(-(i*i+j*j)/(2*sig*sig))/f;
	}

	static NslFloat1 maxim(NslFloat1 u)
	// returns the vector normalized (substraction) by its maximum.
	// only the maximum is above threshold (by 0.01).
	{
		//int imax = u.get_imax(); 
		int imax = u.getSize1(); 
		NslFloat1 c(imax);

		float max = 0;			// Maximum value
		int max_i=0;			// Coordinates of max value
	
		max = NslMaxValue.eval(u);
		if (max == 0)
	 		for (int i=0; i < imax; i++)
				c[i]= - 0.01;
		else
			for (int i=0; i < imax; i++)
				c[i]= u[i] - max + 0.01;

		c = nslStep(c);
		return c;
	}

	static NslFloat2 filter(NslFloat2 view, int f)
	// filters out all the elements in the matrix that do not have a 
	// value of "f". Simplified feature detector where "f" is the feature.
	{
		int i,j;
		//int imax = view.get_imax();
		int imax = view.getSize1();
		NslFloat2 c(imax, imax);

		for (i=0; i<imax; i++)
	  		for (j=0; j<imax; j++)
				if (view[i][j] == f)
					c[i][j] = 1;
				else 
					c[i][j] = 0;	

		return c;
	}
}
