// Funciona

 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

 public class MHM extends NslModule /*(int tectsize)*/ 
{
	public NslDinFloat1 baf ; /*(tectsize)*/			
	public NslFloat1 in ; /*(tectsize)*/
	public NslDinFloat1 gapsf ; /*(tectsize)*/
	public NslDinFloat1 preyHorF ; /*(tectsize)*/			
	public NslDoutFloat1 mhm ; /*(tectsize)*/
	//public NslDoutFloat0 ps();
	public NslDouble0 ps ; /*()*/
	public NslFloat0 d_norm ; /*()*/
	public NslFloat0 d_mhm ; /*()*/
	public NslDinFloat0 pspa ; /*()*/
	public NslDinFloat0 psoa ; /*()*/
	private NslFloat1 mhm_hat ; /*(tectsize)*/		// Predictive MHM.
	private NslFloat0 field_A ; /*()*/
	private NslFloat0 field_center ; /*()*/
	private NslFloat0 rspa ; /*()*/
	private NslFloat0 rsoa ; /*()*/

	public  void initSys()
	{
		rspa.set(1.0);	
		rsoa.set(1.0);	
		ps.set(0);
	}

	public  void simRun()
	{
		// Dynamics of Motor Heading Map (MHM): integrating several fields.
		// New fields can also be added while learning.

		if (
 nslj.src.math.NslGtr.eval(d_mhm.get(),d_norm.get()))
		{			 
			(baf).set(field_center.getint(),field_A);
			in.set(baf); // New Field "inserted"
		}
		else
			in.set(0); // reset input (cf. antidromic
		
		mhm_hat.set(mhm);					// Predictive MHM.
		mhm.set(
 __nsltmp103=nslj.src.math.NslAdd.eval(__nsltmp103,
 __nsltmp102=nslj.src.math.NslAdd.eval(__nsltmp102,
 __nsltmp101=nslj.src.math.NslAdd.eval(__nsltmp101,gapsf.get(),preyHorF.get()),baf.get()),in.get()));		// Fields over MHM.		

		ps.set((
 nslj.src.math.NslAdd.eval(ps.get(),
 nslj.src.math.NslElemMult.eval(rspa.get(),pspa.get())))+(
 nslj.src.math.NslElemMult.eval(rsoa.get(),psoa.get())));   		
   		ps.set(NslSigmoid.eval(ps,-(1.0),1.0,-(1.0),1.0)) /* rule 108 */;	
	}
	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	__nsltmp101 = new float[1];
	__nsltmp102 = new float[1];
	__nsltmp103 = new float[1];
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	for (int i = 0; i < __nsltmp101.length; i++) {
		__nsltmp101[i] = 0;
}
	for (int i = 0; i < __nsltmp102.length; i++) {
		__nsltmp102[i] = 0;
}
	for (int i = 0; i < __nsltmp103.length; i++) {
		__nsltmp103[i] = 0;
}
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	private  float[] __nsltmp101;
	private  float[] __nsltmp102;
	private  float[] __nsltmp103;
	/* constructor and related methods */
	/* nsl declarations */
	int tectsize;

	 /*GENERIC CONSTRUCTOR:   */
	 public MHM(String nslName, NslModule nslParent,int tectsize) {
		super(nslName, nslParent);
		this.tectsize = tectsize;
		initSys();
		makeInst(nslName, nslParent,tectsize);
	}
	public void makeInst(String nslName, NslModule nslParent,int tectsize){ 
	 baf=new NslDinFloat1 ("baf",this,tectsize); //NSLDECLS 
	 in=new NslFloat1 ("in",this,tectsize); //NSLDECLS 
	 gapsf=new NslDinFloat1 ("gapsf",this,tectsize); //NSLDECLS 
	 preyHorF=new NslDinFloat1 ("preyHorF",this,tectsize); //NSLDECLS 
	 mhm=new NslDoutFloat1 ("mhm",this,tectsize); //NSLDECLS 
	 ps=new NslDouble0 ("ps",this); //NSLDECLS 
	 d_norm=new NslFloat0 ("d_norm",this); //NSLDECLS 
	 d_mhm=new NslFloat0 ("d_mhm",this); //NSLDECLS 
	 pspa=new NslDinFloat0 ("pspa",this); //NSLDECLS 
	 psoa=new NslDinFloat0 ("psoa",this); //NSLDECLS 
	 mhm_hat=new NslFloat1 ("mhm_hat",this,tectsize); //NSLDECLS 
	 field_A=new NslFloat0 ("field_A",this); //NSLDECLS 
	 field_center=new NslFloat0 ("field_center",this); //NSLDECLS 
	 rspa=new NslFloat0 ("rspa",this); //NSLDECLS 
	 rsoa=new NslFloat0 ("rsoa",this); //NSLDECLS 
	}
	/* end of automatic declaration statements */
}
