// Funciona

nslImport nslAllImports;

nslModule Xform (int tectsize) 
{
	public NslDinFloat1 wta_mhm(tectsize);	// Predictive MHM.
	public NslDoutFloat0 angle();			// Heading (target) angle.
	//public NslDoutFloat0 ps();
	public NslDouble0 ps();
	public NslDinFloat0 pspa();
	public NslDinFloat0 psoa();
	private NslFloat1 angle_position(tectsize);
	private NslFloat0 rspa();
	private NslFloat0 rsoa();

	public void initSys()
	{
		rspa = 1.0;	
		rsoa = 1.0;	
		ps = 0;
	}

	public void simRun()
	{
		// Sensory motor Transformation from retinotopic coordinates to population coding.

		int i = (int)NslMaxValue.eval(wta_mhm); 
		angle = 0;
		if (i != 0)
			angle = i - wta_mhm.getSize1()/2; 			

		ps = ps + rspa*pspa + rsoa*psoa;   		
   		ps = NslSigmoid.eval(ps,-1.0,1.0,-1.0,1.0);
	}
}
