/*
 * world.java
 *
 * Created on 30 de abril de 2003, 10:17 AM
 */

package cannes.NSLWorld;

import com.sun.j3d.utils.image.TextureLoader;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;

/**
 *
 * @author  rodolfo
 */
public class worldBranchGroup extends BranchGroup{
//    private java.awt.Component comp;
    private Vector3f topView;
    private Vector3f robotView;
    private Vector3f robotCameraView;
    private Vector3f thirdView;
    private TransformGroup robotBodyTranslationGroup;
    private TransformGroup robotBodyRotationGroup;
    private TransformGroup robotCameraTranslationGroup;
    private TransformGroup robotCameraRotationGroup;
    private CollisionReporter reporter = new CollisionReporter();
    
    /** Creates a new instance of world */
    public worldBranchGroup(){//java.awt.Component comp) {
        super();
//        this.comp = comp ;
        this.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        this.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    }
    
    public void addSphere(float r, Color3f color, float xp, float yp, float zp, boolean collidable) {
        //Set appearance
        Appearance app = new Appearance();
        Material mat = createMaterial(color);
        
        app.setMaterial(mat);
	Primitive vol = new Sphere(r, app);

	addVolume(vol, xp, yp, zp);
        if(collidable)
            addCollisionBehavior(vol, xp, yp, zp);
    }
    
    public void addCylinder(float r, float h, Color3f color, float xp, float yp, float zp, boolean collidable) {
        //Set appearance
        Appearance app = new Appearance();
//        Material mat = createMaterial(color);
        TextureLoader loader = null ;
        TextureAttributes ta ;
        
        //Carga de archivo de textura
        try {   
            loader = new com.sun.j3d.utils.image.TextureLoader(
                javax.imageio.ImageIO.read(
                        new java.io.File("c:\\Stone_Checker.jpg"))) ;
        }
        catch(java.io.IOException e) { 
            System.err.println("Erreur d'ouverture d'un fichier image"); 
            e.printStackTrace(); 
        }                   
        
//        app.setMaterial(mat);
        ta=new TextureAttributes();
        app.setTextureAttributes(ta);
        Texture tex = loader.getTexture() ;
        app.setTexture(tex);

        Primitive vol = new Cylinder(r, h, Primitive.GENERATE_TEXTURE_COORDS, app);

	addVolume(vol, xp, yp, zp);
        if(collidable)
            addCollisionBehavior(vol, xp, yp, zp);
    }
    
    public void addBox(float x, float y, float z, Color3f color, float xp, float yp, float zp, boolean collidable) {
        Appearance app;
        TextureAttributes ta;
        Primitive vol;
        PolygonAttributes polyatt ;
        TextureLoader loader = null ;
        
        //Carga de archivo de textura
        try {   
            loader = new com.sun.j3d.utils.image.TextureLoader(
                javax.imageio.ImageIO.read(
                        new java.io.File("c:\\bricks.jpg"))) ;
        }
        catch(java.io.IOException e) { 
            System.err.println("Erreur d'ouverture d'un fichier image"); 
            e.printStackTrace(); 
        }                   
        Texture tex = loader.getTexture() ;
        app=new Appearance();
        ta=new TextureAttributes();
        app.setTextureAttributes(ta);
        app.setTexture(tex);
        vol = new Box(x, y, z, Primitive.GENERATE_TEXTURE_COORDS, app); 
        
	addVolume(vol, xp, yp, zp);
        if(collidable)
            addCollisionBehavior(vol, xp, yp, zp);
    }
    
    public void addVolume(Primitive vol, float x, float y, float z) {
        // Create a TransformGroup and make it the parent of the volume
        Transform3D translate = new Transform3D();
        translate.setTranslation(new Vector3f(x,y,z));
	TransformGroup tg = new TransformGroup(translate);
	tg.addChild(vol);
    
        //add the transform to the BranchGroup
        this.addChild(tg);
        
        tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    }
    
    int id = 0;
    public void addCollisionBehavior(Primitive vol, double x, double y, double z) {
        Behavior collisionbehavior = new CollisionBehavior(reporter, vol, id);
        collisionbehavior.setSchedulingBounds(new BoundingSphere(new Point3d(x, y, z), 2d));
        this.addChild(collisionbehavior);
        id++;
    }
    
    protected TextureAttributes createTextureAttributes() {
        TextureAttributes texatt ;
        Transform3D tt ;
        
        tt = new Transform3D();
        tt.setIdentity();
        tt.setScale(10.);

        texatt = new TextureAttributes();

        texatt.setCapability(TextureAttributes.ALLOW_MODE_WRITE);
        texatt.setCapability(TextureAttributes.ALLOW_BLEND_COLOR_WRITE);
        texatt.setCapability(TextureAttributes.ALLOW_TRANSFORM_WRITE);
        texatt.setTextureMode(TextureAttributes.REPLACE);
        // texatt.setTextureMode( ((Integer)modes[currentMode].value).intValue() );
        texatt.setPerspectiveCorrectionMode( TextureAttributes.NICEST );
        texatt.setTextureTransform(tt);
        texatt.setTextureBlendColor(new Color4f(0.0f, 1.0f, 0.0f, 0.5f));

        return texatt ;
    }
    
    protected Texture createTexture() {
        Texture2D tex = new Texture2D(Texture.BASE_LEVEL, Texture.RGB, 512, 256) ;
        try {   
            tex.setImage(0, 
                new ImageComponent2D(
                    ImageComponent2D.FORMAT_RGB, javax.imageio.ImageIO.read(
                        new java.io.File("c:\\stone_bricks.jpg"))));
       }
        catch(java.io.IOException e) { 
            System.err.println("Erreur d'ouverture d'un fichier image"); 
            e.printStackTrace(); 
        }                   
 
        return tex ;
    }
    protected Material createMaterial(Color3f color) {
	Material mat = new Material();
	mat.setDiffuseColor(color);
	mat.setSpecularColor(new Color3f(((Tuple3f)color).x/2,((Tuple3f)color).y/2,((Tuple3f)color).z/2));//color);
	mat.setShininess(1f);
        
        return mat;
    }
    
    public void setTopView(Vector3f vector) {
        topView = vector;
    }
    
    public void setThirdView(Vector3f vector) {
        thirdView = vector;
    }
    
    public void setRobotView(Vector3f vector, float distanceCameras) {
        Primitive cylinder;
        
        robotView = vector;
        robotCameraView = new Vector3f(vector.x, vector.y+0.05f, vector.z);
        BranchGroup branch = new BranchGroup();
    
        this.distanceCameras = distanceCameras ;
        
        /****************
         robot body
         ***************/
        Appearance app = new Appearance();
        Material mat = createMaterial(new Color3f(0.5f,0f,1f));
        app.setMaterial(mat);
        
	cylinder = new Cylinder(0.025f, .05f, app);
        
        Transform3D rotate = new Transform3D();
        rotate.rotX(Math.PI/180.0d*90);
        this.robotBodyRotationGroup = new TransformGroup();
        this.robotBodyRotationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        this.robotBodyRotationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        this.robotBodyRotationGroup.setTransform(rotate);
        this.robotBodyRotationGroup.addChild(cylinder);
        
        Transform3D translate = new Transform3D();
        translate.setTranslation(robotView);
        this.robotBodyTranslationGroup = new TransformGroup();
        this.robotBodyTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        this.robotBodyTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        this.robotBodyTranslationGroup.setTransform(translate);
        this.robotBodyTranslationGroup.addChild(this.robotBodyRotationGroup);
            
        this.addChild(this.robotBodyTranslationGroup);
        
        /****************
         robot camera
         ***************/
        app = new Appearance();
        mat = createMaterial(new Color3f(0.5f,0.5f,0f));
        app.setMaterial(mat);
        
	cylinder = new Cone(0.025f, 0.1f, app);
//	cylinder = new Cone(0.015f, 0.01f, app);
        
        rotate = new Transform3D();
        rotate.rotX(Math.PI/180.0d*90);
        this.robotCameraRotationGroup = new TransformGroup();
        this.robotCameraRotationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        this.robotCameraRotationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        this.robotCameraRotationGroup.setTransform(rotate);
        this.robotCameraRotationGroup.addChild(cylinder);
        
        translate = new Transform3D();
        translate.setTranslation(robotCameraView);
        this.robotCameraTranslationGroup = new TransformGroup();
        this.robotCameraTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        this.robotCameraTranslationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        this.robotCameraTranslationGroup.setTransform(translate);
        this.robotCameraTranslationGroup.addChild(this.robotCameraRotationGroup);
        this.addChild(this.robotCameraTranslationGroup);
        
        //this.addChild(robotGroup);
    }
    
    public void moveRobot(Vector3f vector) {      
        robotView.x += vector.x;
        robotView.y += vector.y;
        robotView.z += vector.z;
        
        robotCameraView.x += vector.x;
        robotCameraView.y += vector.y;
        robotCameraView.z += vector.z;
        
        /*move robot's body*/
        Transform3D translate = new Transform3D();
        translate.setTranslation(robotView);
        
        this.robotBodyTranslationGroup.setTransform(translate);
        
        /*move robot's camera*/
        translate = new Transform3D();
        translate.setTranslation(robotCameraView);
        
        this.robotCameraTranslationGroup.setTransform(translate);
    }
    
    //se gira todo el robot
    public void rotateRobotBody(double degrees) {
        
        //rotar el cuerpo
        Transform3D rotate = new Transform3D();
        rotate.rotZ(Math.toRadians(-degrees));
        
        Transform3D temp = new Transform3D();
        this.robotBodyRotationGroup.getTransform(temp);
        
        temp.mul(rotate);
        this.robotBodyRotationGroup.setTransform(temp);   
        
        //rotar la camara
        rotate = new Transform3D();
        rotate.rotZ(Math.toRadians(-degrees));
        
        temp = new Transform3D();
        this.robotCameraRotationGroup.getTransform(temp);
        
        temp.mul(rotate);
        this.robotCameraRotationGroup.setTransform(temp);   
    }
    
    public void rotateRobotCamera(double degrees) {
        
        Transform3D rotate = new Transform3D();
        rotate.rotZ(Math.toRadians(-degrees));
        
        Transform3D temp = new Transform3D();
        this.robotCameraRotationGroup.getTransform(temp);
        
        temp.mul(rotate);
        this.robotCameraRotationGroup.setTransform(temp);   
    }
        
    public Vector3f getTopView() {
        return topView;
    }
    
    public Vector3f getRobotView() {
        return robotView;
    }
   
    public float getDistanceCameras() {
        return distanceCameras ;
    }
    
    public Vector3f getRobotCameraView0() {
        float x, y, z;
        x = robotCameraView.x ;
        y = robotCameraView.y ;
        z = robotCameraView.z ;

        return new Vector3f(x-distanceCameras/2, y, z);
    }

    public Vector3f getRobotCameraView1() {
        float x, y, z;
        x = robotCameraView.x ;
        y = robotCameraView.y ;
        z = robotCameraView.z ;

        return new Vector3f(x+distanceCameras/2, y, z);
    }
    
    public Vector3f getThirdView() {
        return thirdView;
    }
    
    public boolean isCollided() {
        return reporter.isCollided();
    }
    
    private float distanceCameras ;
}
