package cannes.CanCam;

import com.sun.media.ui.*;
import javax.media.*;
import javax.media.util.*;
import javax.media.format.*;
import javax.media.control.*;
import javax.media.protocol.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import cannes.CanCam.WriteProtocol.*;


public class ImageCap extends Frame {

  public CaptureDeviceManager captureDeviceManager;
  public CaptureDeviceInfo captureDeviceInfo;
  public Vector vector;
  public VideoFormat videoFormat;
  public JDesktopPane jDesktopPane;
  public FrameInterno frameInterno = null;        // Declaracin de frame interno
  public FileDialog fd = null;
  public CheckboxMenuItem cbAutoLoop = null;
  public Player player = null;
  public Player newPlayer = null;
  public String filename;
  public static boolean kind = false;
  private java.util.Timer timer;
  private DataSource dataSource;

  
  public ImageCap()
  {
    super("CANNES Live WebCam ");
    setLayout(new BorderLayout());
    jDesktopPane = new JDesktopPane();
    jDesktopPane.setDoubleBuffered(true);
    jDesktopPane.setBackground(Color.black);

    add("Center", jDesktopPane);
    setSize(360,340);
    setMenuBar(createMenuBar());
    setVisible(true);

    // Nos ponemos un listener al Frame Principal
    addWindowListener( new WindowAdapter()
    { public void windowClosing(WindowEvent e) {
      dispose();
      System.exit(0);
      }
    });

    // Utilizamos el setHint para utilizar un manejo de recursos ligero
    Manager.setHint(Manager.LIGHTWEIGHT_RENDERER, new Boolean(true));
  }
    
    // Creamos el MenuBar
    private MenuBar createMenuBar()
    {
      ActionListener al = new ActionListener()
      {  
        public void actionPerformed(ActionEvent ae)
        {
	      String command = ae.getActionCommand();
	      if (command.equals("Abrir"))
              {
	        if (fd == null)
                {
	          fd = new FileDialog(ImageCap.this, "Abrir Archivo", FileDialog.LOAD);
	          //fd.setDirectory("/movies");
                }
	        fd.show();
                if (fd.getFile() != null) {
                    String filename = fd.getDirectory() + fd.getFile();
                    openFile("file:" + filename);
	        }
	      }   
          else 
              if (command.equals("Salir")) {
	        System.out.println("Menu Salir");
	        dispose();
	        System.exit(0);
              }
          else 
              if (command.equals("En Vivo")) {
                  System.out.println("Menu En Vivo");
                  openFile("vfw://0");
	      }
          else 
              if ( command.equals("Capturar") ) {
                  System.out.println("Menu Captura");
                  if(frameInterno!=null)
                      new ServerSideProtocol(new JPGWriterThread("c:/imagen.jpg"),frameInterno,5429);
                  else
                      System.out.println("null");
	      }
        }
      };

      MenuBar mb = new MenuBar();
      MenuItem item;

      // Menu de Archivo...
      Menu mnFile = new Menu("Archivo");
      mnFile.add(item = new MenuItem("Salir"));
      item.addActionListener(al);

      // Menu Optativo
      Menu mnOptions = new Menu("Transmisin");
      mnOptions.add(item = new MenuItem("En Vivo"));
      item.addActionListener(al);
      mnOptions.add(item = new MenuItem("Capturar"));
      item.addActionListener(al);

      mb.add(mnFile);
      mb.add(mnOptions);

      return mb;
    }


//  Abrir y cargar un archivo de media data
    public void openFile(String filename)
    {
     Player player = null;
     String mediaFile = filename;
     FormatControl formatControls [];

     // URL de nuestro archivo
     URL url = null;

     try {
         captureDeviceManager = new CaptureDeviceManager();
         vector = new Vector();
         
         vector = captureDeviceManager.getDeviceList(null);// Coregir Formato
         captureDeviceInfo = (CaptureDeviceInfo) vector.elementAt(2);
         
         Format[] formatos=captureDeviceInfo.getFormats();

	// Crear el player correspondiente*/
         try {
             if (kind == false) {
                 dataSource = Manager.createDataSource(captureDeviceInfo.getLocator());
                 formatControls = ((CaptureDevice) dataSource).getFormatControls();

                 for ( int i = 0; i < formatos.length; i++ ) 
                     System.out.println(i + " " +formatos[i].toString());
       
                 for ( int i = 0; i < formatControls.length; i++ )
                     formatControls[i].setFormat(formatos[0]);
       
                 player = Manager.createPlayer(dataSource);
             }
             else {
                 System.out.println(kind);
                 MediaLocator mrl= new MediaLocator(mediaFile);
                 
                 if (mrl == null)
                     System.err.println("Can't build MediaLocator for RTP");
                 
                 player = Manager.createPlayer(mrl);
             }
         }
         catch (NoDataSourceException e) { 
             Fatal("Error al abrir datasource" + e);
         }
         catch (NoPlayerException e) {
             Fatal("Error del Player..." + e);
         }
     }
     catch (MalformedURLException e) {
         Fatal("Error en la direccin..." + e);
     }
     catch (IOException e) { 
         Fatal("Error con archivos..." + e);
     }

     if (player != null) { 
         this.filename = filename;
         frameInterno = new FrameInterno(player, filename);
         System.out.println("Creo el frame interno");
         jDesktopPane.add(frameInterno);
     }
    }

    public static void main(String args[]) {
        ImageCap mdi = new ImageCap();
        System.out.println("Creacion del Frame externo");
    }

    static void Fatal(String s) {
        MessageBox mb = new MessageBox("ALERTA- ", s);
        mb.setTitle("Ni mouser...");
    }
}