/*



 * BandSelector.java



 *



 * Created on June 19, 2002, 12:45 AM



 */







package cannes.Imaging.ops;







/**



 *



 * @author  Rodolfo Cartas, rodolfocartas@ieee.org



 */







import javax.media.jai.*;



import java.awt.image.renderable.*;







/** La clase BandSelector se utiliza para obtener las bandas de una imagen



 * multibanda



 */



public class BandSelector implements ImageSource {



    



    private ImageSource imagesource;



    private PlanarImage source;



    private PlanarImage target;



    private int Band;



    



    /** Crea una nueva instancia de la clase BandSelector.



     * @param source La fuente de imagenes multibanda.



     * @param band El nmero de la banda que se requiere.



     */



    public BandSelector(ImageSource source, int band) {



        this.Band = band;



        this.setSource(source);           



        //System.out.println("BANDA: " + this.Band);



    }



    



    /** Obtiene la imagen del objeto



     * @return La imagen procesada.



     */



    public PlanarImage getImage() {



        return this.target;



    }



    



    /** Regresa la fuente de imagenes de este objeto.



     * @return La fuente de imagenes.



     */    



    public ImageSource getSource() {



        return this.imagesource;



    }



    



    public void reload() {



    }



    



    public void setImage(PlanarImage image) {



        this.source = image;



        this.getBand();



    }



    



    



    public void setSource(ImageSource source) {



        this.imagesource = source;



        this.setImage(imagesource.getImage());



    }



    



    private void getBand() {



        int[] bandIndices;



        bandIndices = new int[1];



        //System.out.println("B " + this.Band);



        bandIndices[0] = this.Band;







        // Construct the ParameterBlock.



        ParameterBlock pb = new ParameterBlock();



        pb.addSource(this.source);



        pb.add(bandIndices);







        // Perform the operation



        target = JAI.create("bandSelect", pb);



    }







}



