/*



 * ImageReader.java



 *



 * Created on 26 de abril de 2002, 08:18 PM



 */







package cannes.Imaging.ops;







/**



 *



 * @author  Rodolfo Cartas, rodolfocartas@ieee.org



 */











import javax.media.jai.*;







/** La clase ImageReader se utiliza para leer imagenes desde archivos



 */



public class ImageReader implements ImageSource{



    



    private String file;



    private PlanarImage image;



    



    private int w, h;



    private boolean resize = false;



    



    /** Crea una nueva instancia de ImageReader que lee desde el



     * archivo file



     * @param file El archivo de lectura



     */



    public ImageReader(String file) {



        this.file = file;



        this.loadImage();



    }



    



    /** Crea una nueva instancia de ImageReader que lee desde el



     * archivo file y obtiene una versin a escala, indicada por h,w



     * @param file El archivo de lectura



     * @param w El nuevo ancho



     * @param h La nueva altura



     */    



    public ImageReader(String file, int w, int h) {



        this.resize = true;



        



        this.file = file;



        this.w = w;



        this.h = h;



        this.loadImage();



    }



    



    public void setImage(PlanarImage image) {



    }



    



    /** Devuelve la imagen leida



     * @return Imagen leda



     */



    public PlanarImage getImage() {



        return this.image;



    }



    



    /** Hace que una instancia de la clase lea el archivo apuntado por file



     * @param file El archivo de lectura



     */



    public void setFile(String file) {



        this.file = file;



        this.loadImage();



    }



    



    /** Lee una imagen */



    public void loadImage() {



        //System.out.println("Leyendo Archivo");



        this.image = JAI.create("fileload", this.file);



        if( this.resize )



         this.image = new Resizer(this.image, this.w, this.h).getImage();



    }



    



    public void reload() {



        this.loadImage();



    }



    



    public void setSource(ImageSource source) {



    }



    



    public ImageSource getSource() {



        return null;



    }



        



    



}



