/*


 * ImageSource.java


 *


 * Created on 27 de abril de 2002, 12:20 AM


 */





package cannes.Imaging.ops;





/**


 *


 * @author  Rodolfo Cartas, rodolfocartas@ieee.org


 */





import javax.media.jai.PlanarImage;





/** Una interfaz para procesar Imagenes


 */


public interface ImageSource {


    


    /** Obtiene la imagen del objeto


     * @return La imagen procesada


     */


    public PlanarImage getImage();


    


    


    /** Indica la imagen fuente para su procesamiento


     * @param image Imagen fuente


     */    


    public void setImage(PlanarImage image);


    


    


    /** Reprocesa la imagen


     */    


    public void reload();


    


    


    /** Indica la fuente de imagen para su procesamiento


     * @param source La fuente de imagen


     */    


    public void setSource(ImageSource source);


    


    


    /** Regresa la fuente de imagen


     * @return La fuente de imagen para el procesamiento


     */    


    public ImageSource getSource();


}


