/*


 * KernelConstructor.java


 *


 * Created on June 3, 2002, 5:18 AM


 */





package cannes.Imaging.ops;





/**


 *


 * @author  Rodolfo Cartas, rodolfocartas@ieee.org


 */





import javax.media.jai.*;





public class KernelConstructor {


    


    public static final int Cleaner = 0;


    public static final int Filler = 1;


    public static final int EdgeDetection = 2;


    


    private static final float[] CleanerKern =


          {


           0.0f, 1.0f, 0.0f,


           1.0f, 1.0f, 1.0f, 


           0.0f, 1.0f, 0.0f, 


          };


    private static final float[] FillerKern =      


          {


           1.0f, 2.0f, 1.0f,


           -1.0f, 0.0f, -1.0f, 


           1.0f, 2.0f, 1.0f, 


          };


    private static final float[] EdgeDetectionKern =


          {


           0.0f, -1.0f, 0.0f,


           -1.0f, 4.0f, -1.0f,


           0.0f, -1.0f, 0.0f


          };


    private KernelJAI kern;


    


    /** Creates a new instance of KernelConstructor */


    public KernelConstructor(float[] array, int h, int w) {


        this.kern = new KernelJAI(w, h, array);


    }


    


    public KernelConstructor(int opt) {


        switch( opt ) {


            case Cleaner: 


                this.kern = new KernelJAI(3, 3, this.CleanerKern);


                break;


            case Filler:


                this.kern = new KernelJAI(3, 3, this.FillerKern);


                break;


            case EdgeDetection:


                this.kern = new KernelJAI(3, 3, this.EdgeDetectionKern);


                break;


        }


    }


    


    public KernelJAI getKernel() {


        return this.kern;


    }


    


}


