/*


 * Resizer.java


 *


 * Created on June 3, 2002, 6:50 AM


 */





package cannes.Imaging.ops;





/**


 *


 * @author  Rodolfo Cartas, rodolfocartas@ieee.org


 */





import java.awt.image.renderable.*;


import javax.media.jai.*;





public class Resizer implements ImageSource {


    


    private PlanarImage origin;


    private PlanarImage target;


    private ImageSource imageSource;


    float w, h;


    


    /** Creates a new instance of Resizer */


    public Resizer(PlanarImage image, int w, int h) {


        this.w = w;


        this.h = h;


        


        this.setImage(image);


    }


    


    public Resizer(ImageSource source, int w, int h) {


        this.w = w;


        this.h = h;


        


        this.setSource( source );


    }


    


    public PlanarImage getImage() {


        return this.target;


    }


    


    public void setImage(PlanarImage image) {


        this.origin = image;


        


        this.Resize();


    }


    


    private void Resize() {


        // Create a ParameterBlock and specify the source and


        // parameters


        ParameterBlock pb = new ParameterBlock();


        pb.addSource(this.origin);                   // The source image


        pb.add(this.w/this.origin.getWidth());                        // The xScale


        pb.add(this.h/this.origin.getHeight());                        // The yScale


        pb.add(0.0F);                       // The x translation


        pb.add(0.0F);                       // The y translation


        pb.add(new InterpolationNearest()); // The interpolation





        // Create the scale operation


        this.target = JAI.create("scale", pb, null);


    }


    


    public ImageSource getSource() {


        return this.imageSource;


    }


    


    public void reload() {


        this.setImage(this.imageSource.getImage());


    }


    


    public void setSource(ImageSource source) {


        this.imageSource = source;


    }


    


}


