/*
 * TopWorldCanvas.java
 *
 * Created on May 9, 2003, 1:09 PM
 */
package cannes.NSLWorld;

import javax.media.j3d.Canvas3D;
import java.io.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.image.codec.jpeg.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;
import com.sun.j3d.utils.universe.*;

import javax.media.j3d.Canvas3D;

// The Universe
import com.sun.j3d.utils.universe.SimpleUniverse;

// The BranchGroup
import javax.media.j3d.BranchGroup;

// For the Box
// The directional light
import javax.media.j3d.DirectionalLight;

// For the bouding sphere of the light source
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Appearance;
import javax.media.j3d.Material;

// Transformgroup
import javax.media.j3d.TransformGroup;


/**
 *
 * @author  rodolfo
 */
public class TopWorldCanvas extends WorldCanvas {
    
    /** Creates a new instance of TopWorldCanvas */
    public TopWorldCanvas(GraphicsConfiguration gc, worldBranchGroup branchGroup) {
	super(gc, branchGroup);
    }
    
     public TopWorldCanvas(GraphicsConfiguration gc) {
	super(gc);
    }
    
    public void finalise() {
        // Then add the branch group into the Universe        
	simpleU.addBranchGraph(rootBranchGroup);

        // rotate camera
        TransformGroup viewTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        Transform3D myTransform3D2 = new Transform3D();
        myTransform3D2.rotX(Math.PI/180.0d*-90);
        
        //
        Viewer v[] = simpleU.getViewingPlatform().getViewers();
        v[0].getView().setFrontClipDistance(0.0001);
        //v[0].getView().setProjectionPolicy(javax.media.j3d.View.PARALLEL_PROJECTION);
	simpleU.getViewingPlatform().setNominalViewingTransform();
        
        // And set up the camera position       
        Transform3D myTransform3D = new Transform3D();
        myTransform3D.setTranslation(rootBranchGroup.getTopView());
        myTransform3D.mul(myTransform3D2);
        viewTrans.setTransform(myTransform3D);
    }
    
    public void moveRobot(Vector3f vector) {
        Vector3f r = rootBranchGroup.getRobotView();
        Point3f pres = new Point3f(r.x,r.y,r.z);
        Point3f next = pres;
        
        //Add trace line
        int format = GeometryArray.COORDINATES |
                 GeometryArray.COLOR_3;

        LineArray lines = new LineArray(2, format);
        float[] vertices = {
            r.x, r.y, r.z,   // v1
            r.x + vector.x, r.y + vector.y, r.z + vector.z   // v2
        };
      
        lines.setCoordinates(0, vertices);
        
        Appearance app = new Appearance();
        Material mat = rootBranchGroup.createMaterial(new Color3f(255,0,0));
        app.setMaterial(mat);
        
        Shape3D shape = new Shape3D(lines, app);
        
        BranchGroup bg = new BranchGroup();
        bg.addChild(shape);
        rootBranchGroup.addChild(bg);

        rootBranchGroup.moveRobot(vector);
    }    
}

